// -*- c++ -*- Tell emacs that this is really C++ even with a lower case 'h'

// FIX: this needs major work

//////////////////////////////
// INCLUDE GUARD
//////////////////////////////

#ifndef __FIX_H__  // replace FIX with filename
#define __FIX_H__

/***************************************************************************
 * INCLUDES
 ***************************************************************************/

// NOTE: include only the files to get this header to pass compilation.

// C language headers that have c++ versions

// C headers without c++ versions (/usr/include)

// C++ headers

// C++ STL - standard template library

// Local headers
// #include "template.h"


/***************************************************************************
 * MACROS and DEFINES
 ***************************************************************************/

// Try to keep macros to a minumum.  
// prefer const variables to #defines

// NDEBUG is the C/C++ standard 
#ifndef NDEBUG
#  define PRINT_CHECKPOINT() cerr << "CHECKPOINT CHARLIE -- " << __FILE__ << ":" << __LINE__ << " in " << __FUNCTION__ << endl
#else
#  define PRINT_CHECKPOINT() // Disappear the same time that asserts vanish
#endif

#ifndef NDEBUG
#  define PRINT_CHECKPOINT_MSG(msg) cerr << msg << " -- " << __FILE__ << ":" << __LINE__ << " in " << __FUNCTION__ << endl
#else
#  define PRINT_CHECKPOINT_MSG(msg)
#endif

/***************************************************************************
 * USE CONST instead of #define in headers.  Must use const 2x
 ***************************************************************************/

/// Use enums to give a range of constant values that are integers
enum GridType { DEM, UNCERTAINTY, ROUGHNESS };
const char * const GridTypeNames[]={"DEM", "UNCERTAINTY", "ROUGHNESS"}; ///< How to provide a quick string version of an enum

enum EnumThatStartsNotAtZero { FIRST=111, SECOND=222, THIRD /* will be 223 */}; /// Force the values.


/***************************************************************************
 * FUNCTION PROTOTYPES
 ***************************************************************************/

/***************************************************************************
 * CLASS DEFINITIONS
 ***************************************************************************/

// Define your classes here.  Remember to use const liberally.
// FIX: Document the class here or in the source?  Which is better?

//////////////////////////////
// INCLUDE GUARD
//////////////////////////////
#endif // __FIX_H__ include guard
